//+------------------------------------------------------------------+
//|                                                  CCI Woodie like |
//|                                                CCI woodie wy.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 9
#property indicator_color1  clrGreen
#property indicator_color2  clrRed
#property indicator_color3  clrYellow
#property indicator_color4  clrLimeGreen
#property indicator_color5  clrTomato
#property indicator_color6  clrLimeGreen
#property indicator_color7  clrTomato
#property indicator_color8  clrDimGray
#property indicator_color9  clrYellowGreen
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2
#property indicator_width6  2
#property indicator_width7  2
#property indicator_width8  2

//
//
//
//
//

extern int                   CCIPeriod        = 14;
extern int                   TrendPeriod      =  6;
extern int                   TurboCCIPeriod     =  0;
extern int                   LSMAPeriod         = 25;
extern ENUM_APPLIED_PRICE    LSMAPrice          = PRICE_CLOSE;
extern int                   EMAPeriod          = 34;
extern ENUM_APPLIED_PRICE    EMAPrice           = PRICE_CLOSE;
extern bool                  ShowLsmaEma        = true;
extern bool                  EMAVisible         = true;
extern bool                  LSMAVisible        = true;
extern bool                  ShowZones          = true;
extern color                 ZonesColor         = C'30,33,36';
extern color                 LinesColor         = C'50,53,56';
extern string                UnqueID            = "Woodies CCI 1";
extern bool                  arrowsVisible      = true;              // Show arrows?
extern bool                  arrowsOnLsmaCross  = true;              // Show arrows on slope change?
extern bool                  arrowsOnEmaCross   = false;             // Show arrows on zero cross?            
extern string                arrowsIdentifier   = "wcci arrows1"; // Arrows ID
extern double                arrowsUpperGap     = 0.5;               // Arrows Upper Gap
extern double                arrowsLowerGap     = 0.5;               // Arrows lower gap
extern color                 arrowsUpColor      = clrLimeGreen;      // Up arrow color
extern color                 arrowsDnColor      = clrRed;            // Down arrows color
extern int                   arrowsUpCode       = 241;               // Up arrow code
extern int                   arrowsDnCode       = 242;               // Down arrow code
extern bool                  arrowsUpSize       = 2;                 // Up arrow size
extern bool                  arrowsDnSize       = 2;                 // Down arrow size
input bool   EnableNativeAlerts = true;
input bool   EnableSoundAlerts  = true;
input bool   EnableEmailAlerts  = true;
input bool   EnablePushAlerts  = true;
input string AlertEmailSubject  = "";
input string AlertText          = "";
input string SoundFileName      = "alert.wav";

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffery[];
double buffer3[];
double buffer4[];
double buffer5[];
double buffer6[];
double buffer7[];
double buffer8[];
double lsmatrend[];
double ematrend[];
string ShortName;
int    Window;
int    NameLen;
double emalValue;
double lsmlValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int init()
{
   IndicatorBuffers(11);
   emalValue = -5; lsmlValue = 5;
   int emaStyle = DRAW_NONE; if (EMAVisible)  emaStyle = DRAW_LINE;  else lsmlValue = 0;
   int lsmStyle = DRAW_NONE; if (LSMAVisible) lsmStyle = DRAW_LINE;  else emalValue = 0;
   SetIndexBuffer(0, buffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1, buffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2, buffery); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3, buffer3); SetIndexStyle(3,lsmStyle);
   SetIndexBuffer(4, buffer4); SetIndexStyle(4,lsmStyle);
   SetIndexBuffer(5, buffer5); SetIndexStyle(5,emaStyle);
   SetIndexBuffer(6, buffer6); SetIndexStyle(6,emaStyle);
   SetIndexBuffer(7, buffer7);
   SetIndexBuffer(8, buffer8);
   SetIndexBuffer(9, lsmatrend);
   SetIndexBuffer(10,ematrend);
         SetIndexLabel(0,"Trend up");
         SetIndexLabel(1,"Trend down");
         SetIndexLabel(3,"Close above LSMA");
         SetIndexLabel(4,"Close bellow LSMA");
         SetIndexLabel(5,"Close above EMA");
         SetIndexLabel(6,"Close bellow EMA");
         SetIndexLabel(7,"CCI");
         SetIndexLabel(8,"Turbo CCI");


   //
   //
   //
   //
   //

   TrendPeriod = MathMax(3,TrendPeriod);  
   ShortName = UnqueID+" ("+CCIPeriod+","+TurboCCIPeriod+")";
   IndicatorShortName(ShortName);
   return(0);
}
int deinit()
{
   DeleteBounds();
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           Window=WindowFind(ShortName);           

   //
   //
   //
   //
   //
   
   for (int i=limit;i>=0;i--)
   {
      if (TurboCCIPeriod>1) buffer8[i] = iCCI(NULL,0,TurboCCIPeriod,PRICE_TYPICAL,i); 
                            buffer7[i] = iCCI(NULL,0,CCIPeriod     ,PRICE_TYPICAL,i);
            SetHisto(i);
            if (ShowLsmaEma) SetLsmaEma(i);
   }

   if (ShowZones) UpdateBounds();
   return(0);
}
  
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void SetHisto(int i)
{
   int k,s;

   buffer1[i] = EMPTY_VALUE;
   buffer2[i] = EMPTY_VALUE;
   buffery[i] = EMPTY_VALUE;
   
   //
   //
   //
   //
   //

      if (buffer7[i]>0)
         if (buffer1[i+1] != EMPTY_VALUE) s = TrendPeriod;
         else
            for (k=1,s= 1; k<TrendPeriod; k++,s++) if (buffer2[i+k] != EMPTY_VALUE) break;

      if (buffer7[i]<0)
         if (buffer2[i+1] != EMPTY_VALUE) s = -TrendPeriod;
         else
            for (k=1,s=-1; k<TrendPeriod; k++,s--) if (buffer1[i+k] != EMPTY_VALUE) break;

      if (s ==  TrendPeriod) buffer1[i] = buffer7[i];
      if (s == -TrendPeriod) buffer2[i] = buffer7[i];
      if ((MathAbs(s) == (TrendPeriod-1))) buffery[i] = buffer7[i];
   
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void SetLsmaEma(int i)
{
   double lsmaValue = iLsma(i);
   double emaValue  = iMA(NULL,0,EMAPeriod,0,MODE_EMA,EMAPrice,i);
   
   buffer3[i] = EMPTY_VALUE;
   buffer4[i] = EMPTY_VALUE;
   buffer5[i] = EMPTY_VALUE;
   buffer6[i] = EMPTY_VALUE;
   lsmatrend[i] = lsmatrend[i+1];
   ematrend[i]  = ematrend[i+1];
      if (Close[i] > lsmaValue) { buffer3[i] =  lsmlValue; lsmatrend[i] = 1;  }
      if (Close[i] < lsmaValue) { buffer4[i] =  lsmlValue; lsmatrend[i] =-1;  }
      if (Close[i] > emaValue)  { buffer5[i] =  emalValue; ematrend[i]  = 1;  }
      if (Close[i] < emaValue)  { buffer6[i] =  emalValue; ematrend[i]  =-1;  }
      
      //
      //
      //
      //
      //
      
      if (arrowsVisible)
      {
         ObjectDelete(arrowsIdentifier+":1:"+(string)Time[i]);
         ObjectDelete(arrowsIdentifier+":2:"+(string)Time[i]);
         string lookFor = arrowsIdentifier+":"+(string)Time[i]; ObjectDelete(lookFor);
         if (i<(Bars-1) && arrowsOnLsmaCross && lsmatrend[i] != lsmatrend[i+1])
         {
            if (lsmatrend[i] == 1) drawArrow("1",0.5,i,arrowsUpColor,arrowsUpCode,arrowsUpSize,false);
            if (lsmatrend[i] ==-1) drawArrow("1",0.5,i,arrowsDnColor,arrowsDnCode,arrowsDnSize,true);
              {
              if (EnableNativeAlerts) Alert("Signal on " + Symbol() + ".");
                if (EnableEmailAlerts) SendMail("CCI Alert", "Signal on " + TimeToString(Time[0]) + " on " + Symbol() + ".");
                if (EnableSoundAlerts) PlaySound(alert.wav);
                if (EnablePushAlerts) SendNotification("CCI Alert " + TimeToString(Time[0]) + " on " + Symbol() + ".");
                LastAlertTime = Time[0];
                }
              }
              if (i<(Bars-1) && arrowsOnEmaCross && ematrend[i] != ematrend[i+1])
              {
                if (ematrend[i] == 1) drawArrow("2",1,i,arrowsUpColor,arrowsUpCode,arrowsUpSize,false);
                if (ematrend[i] ==-1) drawArrow("2",1,i,arrowsDnColor,arrowsDnCode,arrowsDnSize,true);
              {
              if (EnableNativeAlerts) Alert("Signal on " + Symbol() + ".");
                if (EnableEmailAlerts) SendMail("CCI Alert", "Signal on " + TimeToString(Time[0]) + " on " + Symbol() + ".");
                if (EnableSoundAlerts) PlaySound(alert.wav);
                if (EnablePushAlerts) SendNotification("CCI Alert " + TimeToString(Time[0]) + " on " + Symbol() + ".");
                LastAlertTime = Time[0];
		      	}
		      	}
            }
}

//
//
//
//
//

double iLsma(int shift)
{
   double lengthvar = (LSMAPeriod + 1.0)/3.0;
   double sum       = 0.0;
   double res       = 0.0;

   for(int i = LSMAPeriod; i > 0; i--)
      sum += (i-lengthvar)*iMA(NULL,0,1,0,MODE_SMA,LSMAPrice,shift+LSMAPeriod-i);
      res  = sum*6.0/(LSMAPeriod*(LSMAPeriod+1.0));
   return(res);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string MakeUniqueName(string first, string rest)
{
   string result = first+(MathRand()%1001)+rest;

   while (WindowFind(result)> 0)
          result = first+(MathRand()%1001)+rest;
   return(result);
}

//
//
//
//
//

void DeleteBounds()
{
   ObjectDelete(ShortName+"-1"); ObjectDelete(ShortName+"-11"); ObjectDelete(ShortName+"-12");
   ObjectDelete(ShortName+"-2"); ObjectDelete(ShortName+"-21"); ObjectDelete(ShortName+"-22");
   ObjectDelete(ShortName+"-3"); ObjectDelete(ShortName+"-31"); ObjectDelete(ShortName+"-32");
}
void UpdateBounds()
{
   SetUpBound(ShortName+"-1", 300, 200);
   SetUpBound(ShortName+"-2", 100,-100);
   SetUpBound(ShortName+"-3",-200,-300);
}

//
//
//
//
//

void SetUpBound(string name, double up, double down)
{
   if (ObjectFind(name) == -1)
      {
         ObjectCreate(name,OBJ_RECTANGLE,Window,0,0);
            ObjectSet(name,OBJPROP_PRICE1,up);
            ObjectSet(name,OBJPROP_PRICE2,down);
            ObjectSet(name,OBJPROP_COLOR,ZonesColor);
            ObjectSet(name,OBJPROP_BACK,true);
            ObjectSet(name,OBJPROP_TIME1,iTime(NULL,0,Bars-1));
      }
   if (ObjectGet(name,OBJPROP_TIME2) != iTime(NULL,0,0))
       ObjectSet(name,OBJPROP_TIME2,    iTime(NULL,0,0));
      
   //
   //
   //
   //
   //
          
   if (ObjectFind(name+"1") == -1) drawLine(name+"1",up);
   if (ObjectGet(name+"1",OBJPROP_TIME2) != iTime(NULL,0,0))
       ObjectSet(name+"1",OBJPROP_TIME2,    iTime(NULL,0,0));
   if (ObjectFind(name+"2") == -1) drawLine(name+"2",down);
   if (ObjectGet(name+"2",OBJPROP_TIME2) != iTime(NULL,0,0))
       ObjectSet(name+"2",OBJPROP_TIME2,    iTime(NULL,0,0));
}

//
//
//
//
//

void drawLine(string name, double current)
{
   ObjectCreate(name,OBJ_TREND,Window,iTime(NULL,0,Bars-1),current,Time[0],current);
      ObjectSet(name,OBJPROP_COLOR,LinesColor);
      ObjectSet(name,OBJPROP_RAY,false);
      ObjectSet(name,OBJPROP_BACK,true);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void drawArrow(string nameAdd, double gapMul, int i,color theColor, int theCode, int theWidth, bool up)
{
   string name = arrowsIdentifier+":"+nameAdd+":"+(string)Time[i];
   double gap  = iATR(NULL,0,20,i)*gapMul;   
   
      //
      //
      //
      //
      //
      
     // int add = 0; if (!arrowsOnFirst) add = _Period*60-1;
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_WIDTH,theWidth);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}